/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Aplikace.Inventarizace;

import Aplikace.CasovyPlan.CasovyPlan;
import Aplikace.Katedra.IOsoba;
import Aplikace.Katedra.Katedra;
import java.util.Date;

/**
 *
 * @author Administrator
 */
public class Inventarizace {

    private CasovyPlan casovyPlan = new CasovyPlan();
    private Katedra katedra = new Katedra();

    /**
     * Zrušení Časového planu a Katedry
     */
    public void zrus() {
        this.casovyPlan.zrus();
        this.katedra.zrus();
    }

    /**
     * Test prázdnosti Časového planu
     */
    public boolean jePrazdny() {
        return this.casovyPlan.jePrazdny();
    }

    /**
     * vložení časové jednotky na odpovídající místo do časového plánu
     */
    public void naplanujCasovouJednotku() {
        this.casovyPlan.vlozCasovouJednotku(new Date(new Date().getTime()));
    }

    public void naplanujCasovouJednotku(Date date) {
        this.casovyPlan.vlozCasovouJednotku(date);
    }

    /**
     * vložení osoby do aktuální katedry
     */
    public void vlozOsobu(IOsoba osoba) {
        this.katedra.vlozList(osoba);
    }

    public void vlozOsobu(Katedra katedra, IOsoba osoba) {
        katedra.vlozList(osoba);
    }

    public void priradKCasu() {
        this.casovyPlan.pridejCasovouJednotku(this.katedra);
    }

    /**
     * přiřazení katedry k dané časové jednotce
     */
    public void priradKCasu(Katedra katedra) {
        this.casovyPlan.pridejCasovouJednotku(katedra);
    }

    /**
     * přesun katedry/oddělení na náhradní termín(k náhradní  časové jednotce)
     */
    public void zaraďNaNahradniCas(IOsoba osoba, Date date) {
        this.katedra.vyhledejOsobu(osoba);
        this.casovyPlan.pridejCasovouJednotku(this.katedra.odeberPodstrom(), date);
    }

    /**
     * vypíše jednotlivé osoby, které jsou inventarizovány
     */
    public void inventarizuj() {
        System.out.println("Inventarizace probíhá automaticky, tedy není možné "
                + "zjistit inventarizované osoby samostatně :)");
    }

    /**
     * umožňuje procházení PF včetně kateder/oddělení, pro které  je plánovaná inventarizace.
     */
    public void vypis() {
        System.out.println(this.casovyPlan.toString());
    }
}
